<?php
/*
 *
 * Copyright © Andrea Micheloni 2010
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

// Standard credit card sizes in points (pdflib likes points)
const CREDITCARD_WIDTH=242.64566929133858267716535433070866; 
const CREDITCARD_HEIGHT=153.01417322834645669291338582677165;
const CREDITCARD_ARC=7;
const CREDITCARD_MARGIN=2;
const CREDITCARD_BORDER_SIZE=0.65;

const TABLE_BORDER_SIZE=0.25;

const CARD_TITLE="tankmiche.com";
const NUMBER_DESCRIPTION="CARD IDENTIFICATION NUMBER";
const HOLDER_DESCRIPTION="CARDHOLDER";
const TABLE_TITLE="SECRET CODES - KEEP SAFE";
const LOGO_FILE="logo.png";
const CODES_ROWS=6;
const CODES_COLS=10;

const SECRET_KEY="b8d727f4d0811a4a68317ef0ad31af989d2fd1fe032268b4a6659ba7153f2ab7f62d14c0cd5d24696b7990def37d86e9b34f96fcd7c45cc24066e77482fdcb60";

$color_schemes = array("orange" => array("card_title" => "995500", "front_background" => "ffaa00", "front_border" => "ffcc33", "front_decoration" => "ffcc33",
		"back_background" => "ffffff", "back_border" => "ffdd44", "back_decoration" => "ffeeaa",
		"front_identification" => "dadada", "front_identification_shadow" => "6e6873", "front_descriptions" => "444400",
		"table_border" => "995500", "table_numbers" => "995500", "table_title" => "cc7700", "table_codes" => "332200"),
	"blueish" => array("card_title" => "005599", "front_background" => "00aaff", "front_border" => "33ccff", "front_decoration" => "33ccff",
		"back_background" => "ffffff", "back_border" => "44ddff", "back_decoration" => "aaeeff",
		"front_identification" => "dadada", "front_identification_shadow" => "73686e", "front_descriptions" => "004444",
		"table_border" => "005599", "table_numbers" => "005599", "table_title" => "0077cc", "table_codes" => "002233"),
	"gray" => array("card_title" => "333333", "front_background" => "cccccc", "front_border" => "dddddd", "front_decoration" => "dddddd",
		"back_background" => "ffffff", "back_border" => "eeeeee", "back_decoration" => "dddddd",
		"front_identification" => "999999", "front_identification_shadow" => "6a6a6a", "front_descriptions" => "444444",
		"table_border" => "666666", "table_numbers" => "666666", "table_title" => "666666", "table_codes" => "222222"));

$fonts = array("card_title" => array('name'=>'Helvetica-BoldOblique', 'color'=>'card_title', 'size'=>'20'),
	"card_number" => array('name'=>'Courier-Bold', 'color'=>'front_identification', 'size'=>'18'),
	"card_number_shadow" => array('name'=>'Courier-Bold', 'color'=>'front_identification_shadow', 'size'=>'18'),
	"card_holder" => array('name'=>'Courier-Bold', 'color'=>'front_identification', 'size'=>'15'),
	"card_holder_shadow" => array('name'=>'Courier-Bold', 'color'=>'front_identification_shadow', 'size'=>'15'),
	"front_descriptions" => array('name'=>'Helvetica', 'color'=>'front_descriptions', 'size'=>'5'),
	"table_numbers" => array('name'=>'Helvetica', 'color'=>'table_numbers', 'size'=>'5'),
	"table_title" => array('name'=>'Helvetica', 'color'=>'table_title', 'size'=>'6'),
	"table_codes" => array('name'=>'Courier-Bold', 'color'=>'table_codes', 'size'=>'8'));

$positions = array("card_title" => array('x' => CREDITCARD_WIDTH/12, 'y' => CREDITCARD_HEIGHT*8/10),
	"card_logo" => array('x' => CREDITCARD_WIDTH*15/19, 'y' => CREDITCARD_HEIGHT*13/20),
	"card_number" => array('x' => CREDITCARD_WIDTH/12, 'y' => CREDITCARD_HEIGHT*2/5),
	"card_number_description" => array('x' => CREDITCARD_WIDTH/12, 'y' => CREDITCARD_HEIGHT*2/5-7.5),
	"card_number_shadow_left" => array('x' => CREDITCARD_WIDTH/12-0.3, 'y' => CREDITCARD_HEIGHT*2/5-0.3),
	"card_number_shadow_right" => array('x' => CREDITCARD_WIDTH/12+0.3, 'y' => CREDITCARD_HEIGHT*2/5-0.3),
	"card_holder" => array('x' => CREDITCARD_WIDTH/12, 'y' => CREDITCARD_HEIGHT/6),
	"card_holder_shadow_left" => array('x' => CREDITCARD_WIDTH/12-0.3, 'y' => CREDITCARD_HEIGHT/6-0.3),
	"card_holder_shadow_right" => array('x' => CREDITCARD_WIDTH/12+0.3, 'y' => CREDITCARD_HEIGHT/6-0.3),
	"card_holder_description" => array('x' => CREDITCARD_WIDTH/12, 'y' => CREDITCARD_HEIGHT/6-7.5),
	"table_topright" => array('x' => CREDITCARD_WIDTH*16/17, 'y' => CREDITCARD_HEIGHT*19/22),
	"table_bottomleft" => array('x' => CREDITCARD_WIDTH/17, 'y' => CREDITCARD_HEIGHT/11),
	"table_title" => array('x' => CREDITCARD_WIDTH/17, 'y' => CREDITCARD_HEIGHT*10/11),
	"table_numbers" => array('x' => 1.5, 'y' => -5),
	"table_codes" => array('x' => 3, 'y' => -15));

function load_params(){
	global $card_number, $card_holder;

	$number=htmlspecialchars($_POST['n']);
	$holder=htmlspecialchars($_POST['h']);
	$color_scheme=htmlspecialchars($_POST['c']);

	if($number=='')
		die('No card id!');
	if($holder=='')
		die('No cardholder!');
	if(preg_match('/^[0-9]+$/',$number)==0)
		die('Card id must be a number!');
	if(preg_match('/^[a-zA-Z ,.]+$/',$holder)==0)
		die('Card holder must be a name!');
	if(strlen($number)>16)
		die('Card id is too long!');
	if(strlen($holder)>23)
		die('Card holder is too long!');
	if($color_scheme=='')
		set_color_scheme("blueish");
	else
		set_color_scheme($color_scheme);

	$card_number=substr($number,0,4).' '.substr($number,4,4).' '.substr($number,8,4).' '.substr($number,12,4);
	$card_holder=$holder;
}

function init_pdf(){
	global $p, $card_holder;

	$p = PDF_new();

	if (PDF_begin_document($p, "", "") == 0) {
		die("Error: " . PDF_get_errmsg($p));
	}

	PDF_set_info($p, "Creator", "Card-O-Matic demo");
	PDF_set_info($p, "Author", "Card-O-Matic demo");
	PDF_set_info($p, "Title", "Code card for \"".$card_holder."\"");

	PDF_begin_page_ext($p, CREDITCARD_WIDTH+CREDITCARD_MARGIN*2 ,(CREDITCARD_HEIGHT+CREDITCARD_MARGIN*2)*2, "");
}

function draw_pdf()
{
	draw_back(CREDITCARD_MARGIN, CREDITCARD_MARGIN);
	draw_front(CREDITCARD_MARGIN, CREDITCARD_HEIGHT+CREDITCARD_MARGIN*3);
}

function end_pdf()
{
	global $p;

	PDF_end_page_ext($p, "");
	PDF_end_document($p, "");
}

function output_pdf()
{
	global $p;

	$buf = PDF_get_buffer($p);
	$len = strlen($buf);

	header("Content-type: application/pdf");
	header("Content-Length: $len");
	header("Content-Disposition: inline; filename=card.pdf");
	print $buf;

	PDF_delete($p);
}

function set_color_scheme($color_scheme_name){
	global $colors;

	$colors=find_color_scheme($color_scheme_name);
}

function find_color_scheme($color_scheme_name){
	global $color_schemes;

	return $color_schemes[$color_scheme_name];
}

function draw_back($x, $y){
	global $p;

	draw_card($x, $y, 'back_background', 'back_border');
	draw_decorations($x, $y, 'back_decoration', 'back_border');

	draw_table($x, $y);
}

function draw_front($x, $y){
	global $p, $card_number, $card_holder;

	draw_card($x, $y, 'front_background', 'front_border');
	draw_decorations($x, $y, 'front_decoration', 'front_border');

	draw_logo($x, $y);
	draw_text(CARD_TITLE, $x, $y, 'card_title', 'card_title');

	draw_text($card_number, $x, $y, 'card_number_shadow_left', 'card_number_shadow');
	draw_text($card_number, $x, $y, 'card_number_shadow_right', 'card_number_shadow');
	draw_text($card_number, $x, $y, 'card_number', 'card_number');

	draw_text($card_holder, $x, $y, 'card_holder_shadow_left', 'card_holder_shadow');
	draw_text($card_holder, $x, $y, 'card_holder_shadow_right', 'card_holder_shadow');
	draw_text($card_holder, $x, $y, 'card_holder', 'card_holder');

	draw_text(NUMBER_DESCRIPTION, $x, $y, 'card_number_description', 'front_descriptions');
	draw_text(HOLDER_DESCRIPTION, $x, $y, 'card_holder_description', 'front_descriptions');
}

function draw_card($x, $y, $color_background, $color_border)
{
	global $p;

	$y = $y+CREDITCARD_HEIGHT;
	set_color($color_background, "fill");
	set_color($color_border, "stroke");
	set_border_size(CREDITCARD_BORDER_SIZE);

	pdf_moveto($p, $x, $y-CREDITCARD_ARC);
	pdf_lineto($p, $x, $y-CREDITCARD_HEIGHT+CREDITCARD_ARC);
	pdf_arc($p, $x+CREDITCARD_ARC, $y-CREDITCARD_HEIGHT+CREDITCARD_ARC, CREDITCARD_ARC, 180, 270);
	pdf_lineto($p, $x+CREDITCARD_WIDTH-CREDITCARD_ARC, $y-CREDITCARD_HEIGHT);
	pdf_arc($p, $x+CREDITCARD_WIDTH-CREDITCARD_ARC, $y-CREDITCARD_HEIGHT+CREDITCARD_ARC, CREDITCARD_ARC, 270, 360);
	pdf_lineto($p, $x+CREDITCARD_WIDTH, $y-CREDITCARD_ARC);
	pdf_arc($p, $x+CREDITCARD_WIDTH-CREDITCARD_ARC, $y-CREDITCARD_ARC, CREDITCARD_ARC,0,90);
	pdf_lineto($p, $x+CREDITCARD_ARC, $y);
	pdf_arc($p, $x+CREDITCARD_ARC, $y-CREDITCARD_ARC, CREDITCARD_ARC,90,180);

	pdf_fill_stroke($p);
}

function draw_decorations($x, $y, $color_background, $color_border='')
{
	global $p;

	$dec1=CREDITCARD_HEIGHT/1.5;
	$dec2=CREDITCARD_HEIGHT/1.2;
	$y = $y+CREDITCARD_HEIGHT;
	set_color($color_background);

	pdf_moveto($p, $x, $y-CREDITCARD_HEIGHT+$dec1);
	pdf_lineto($p, $x, $y-CREDITCARD_HEIGHT+CREDITCARD_ARC);
	pdf_arc($p, $x+CREDITCARD_ARC, $y-CREDITCARD_HEIGHT+CREDITCARD_ARC, CREDITCARD_ARC, 180, 270);
	pdf_lineto($p, $x+$dec1, $y-CREDITCARD_HEIGHT);
	pdf_arc($p, $x, $y-CREDITCARD_HEIGHT, $dec1, 0,90);

	pdf_moveto($p, $x+CREDITCARD_WIDTH, $y-CREDITCARD_HEIGHT+$dec2);
	pdf_lineto($p, $x+CREDITCARD_WIDTH, $y-CREDITCARD_ARC);
	pdf_arc($p, $x+CREDITCARD_WIDTH-CREDITCARD_ARC, $y-CREDITCARD_ARC, CREDITCARD_ARC,0,90);
	pdf_lineto($p, $x+CREDITCARD_WIDTH-$dec2, $y);
	pdf_arc($p, $x+CREDITCARD_WIDTH, $y, $dec2, 180,270);

	pdf_fill($p);

	if($color_border!='')
	{
		set_color($color_border, "stroke");

		pdf_moveto($p, $x, $y-CREDITCARD_HEIGHT+$dec1);
		pdf_lineto($p, $x, $y-CREDITCARD_HEIGHT+CREDITCARD_ARC);
		pdf_arc($p, $x+CREDITCARD_ARC, $y-CREDITCARD_HEIGHT+CREDITCARD_ARC, CREDITCARD_ARC, 180, 270);
		pdf_lineto($p, $x+$dec1, $y-CREDITCARD_HEIGHT);
	
		pdf_moveto($p, $x+CREDITCARD_WIDTH, $y-$dec2);
		pdf_lineto($p, $x+CREDITCARD_WIDTH, $y-CREDITCARD_ARC);
		pdf_arc($p, $x+CREDITCARD_WIDTH-CREDITCARD_ARC, $y-CREDITCARD_ARC, CREDITCARD_ARC,0,90);
		pdf_lineto($p, $x+CREDITCARD_WIDTH-$dec2, $y);

		pdf_stroke($p);
	}
}


function draw_table($x, $y){
	$table_topright=find_position('table_topright');
	$table_bottomleft=find_position('table_bottomleft');

	$table_x=$x+$table_bottomleft['x'];
	$table_y=$y+$table_bottomleft['y'];
	$table_w=$table_topright['x']-$table_bottomleft['x'];
	$table_h=$table_topright['y']-$table_bottomleft['y'];

	draw_table_borders($table_x, $table_y, $table_w, $table_h, 'table_border');
	draw_table_numbers($table_x, $table_y, $table_w, $table_h, 'table_numbers');
	draw_table_codes($table_x, $table_y, $table_w, $table_h, 'table_codes');

	draw_text(TABLE_TITLE, $x, $y, 'table_title', 'table_title');
}

function draw_table_borders($x, $y, $w, $h, $color_border)
{
	global $p;

	$y = $y+$h;
	$row_height=$h/CODES_ROWS;
	$col_width=$w/CODES_COLS;

	set_border_size(TABLE_BORDER_SIZE);
	set_color($color_border);

	for($i=0; $i<=CODES_ROWS; $i++){
		pdf_moveto($p, $x+$margin, $y-$h+$margin+$row_height*$i);
		pdf_lineto($p, $x+$w-$margin, $y-$h+$margin+$row_height*$i);
	}

	for($i=0; $i<=CODES_COLS; $i++){
		pdf_moveto($p, $x+$margin+$col_width*$i, $y-$h+$margin);
		pdf_lineto($p, $x+$margin+$col_width*$i, $y-$margin-$margin_top);
	}

	pdf_stroke($p);
}

function draw_table_numbers($x, $y, $w, $h, $font)
{
	global $p;

	$y = $y+$h;
	$row_height=$h/CODES_ROWS;
	$col_width=$w/CODES_COLS;
	$relpos=find_position('table_numbers');

	set_font($font);

	for($i=0; $i<CODES_ROWS; $i++){
		for($j=0; $j<CODES_COLS; $j++){
			PDF_set_text_pos($p, $x+$margin+$j*$col_width+$relpos['x'], $y-$margin_top-$margin-$row_height*$i+$relpos['y']);
			PDF_show($p, $j+$i*CODES_COLS+1);
		}
	}

}

function draw_table_codes($x, $y, $w, $h, $font)
{
	global $p;

	$y = $y+$h;
	$row_height=$h/CODES_ROWS;
	$col_width=$w/CODES_COLS;
	$relpos=find_position('table_codes');

	$code=get_code();
	set_font($font);

	for($i=0; $i<CODES_ROWS; $i++){
		for($j=0; $j<CODES_COLS; $j++){
			PDF_set_text_pos($p, $x+$margin+$j*$col_width+$relpos['x'], $y-$margin_top-$margin-$row_height*$i+$relpos['y']);
			PDF_show($p, substr($code,3*($j+$i*CODES_COLS),3));
		}
	}

}

function draw_logo($x, $y){
	global $p;

	$pos=find_position("card_logo");

	$logo = pdf_load_image($p, "png", LOGO_FILE, "");
	pdf_fit_image($p, $logo, $x+$pos['x'], $y+$pos['y'], "boxsize {36 40} fitmethod meet");
	pdf_close_image($p, $logo);
}

function get_code(){
	global $card_number;

	$sha256=hash("sha256", $card_number.SECRET_KEY);
	$sha512=hash("sha512", $card_number.SECRET_KEY);

	$code=strtoupper($sha256.$sha512);

	return $code;
}

function draw_text($text, $x, $y, $position_id, $font_id){
	global $p;

	set_font($font_id);
	set_text_position($x, $y, $position_id);
	PDF_show($p, $text);
}

function set_border_size($size){
	global $p;

	pdf_setlinewidth($p, $size);
}

function set_color($color_name, $scope="both"){
	set_rgb(find_rgb($color_name), $scope);
}

function set_font($font_id){
	global $p;

	$font_arr = find_font($font_id);
	$font_pdf = PDF_load_font($p, $font_arr['name'], "winansi", "");

	set_color($font_arr['color']);
	PDF_setfont($p, $font_pdf, $font_arr['size']);
}

function set_text_position($x, $y, $position_name){
	global $p;

	$position = find_position($position_name);

	PDF_set_text_pos($p, $x+$position['x'], $y+$position['y']);
}

function set_rgb($rgb, $scope="both"){
	global $p;

	$red=	hexdec(substr($rgb, 0, 2))/255;
	$green=	hexdec(substr($rgb, 2, 2))/255;
	$blue=	hexdec(substr($rgb, 4, 2))/255;

	pdf_setcolor($p, $scope, 'rgb', $red, $green, $blue, 0);
}

function find_font($font_id){
	global $fonts;

	return $fonts[$font_id];
}

function find_position($position_name){
	global $positions;

	return $positions[$position_name];
}

function find_rgb($color_name){
	global $colors;

	return $colors[$color_name];
}

// Too high level you say?

	load_params();
	
		init_pdf();

			draw_pdf();

		end_pdf();

	output_pdf();

?>
